// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "api.proto" (package "proxy", syntax proto3)
// tslint:disable
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import { WireType } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MESSAGE_TYPE } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { Server } from "./messages";
import { Backend } from "./messages";
import { Routing } from "./messages";
import { Listener } from "./messages";
/**
 * @generated from protobuf message proxy.Configstore
 */
export interface Configstore {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string; // @gotags: yaml:"name,omitempty" gorm:"column:name;primaryKey" mapstructure:"name"
    /**
     * @generated from protobuf field: string Type = 2 [json_name = "Type"];
     */
    type: string; // @gotags: yaml:"type,omitempty" gorm:"column:type;primaryKey" mapstructure:"type"
    /**
     * @generated from protobuf field: bytes Data = 3 [json_name = "Data"];
     */
    data: Uint8Array;
}
/**
 * @generated from protobuf message proxy.GetListenerResponse
 */
export interface GetListenerResponse {
    /**
     * @generated from protobuf field: repeated proxy.Listener Listener = 1 [json_name = "Listener"];
     */
    listener: Listener[];
}
/**
 * @generated from protobuf message proxy.RemoveListenerRequest
 */
export interface RemoveListenerRequest {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: string DevelopmentName = 2 [json_name = "DevelopmentName"];
     */
    developmentName: string;
    /**
     * @generated from protobuf field: bool RemoveByDevelopment = 3 [json_name = "RemoveByDevelopment"];
     */
    removeByDevelopment: boolean;
}
/**
 * @generated from protobuf message proxy.GetRoutingResponse
 */
export interface GetRoutingResponse {
    /**
     * @generated from protobuf field: repeated proxy.Routing Routing = 1 [json_name = "Routing"];
     */
    routing: Routing[];
}
/**
 * @generated from protobuf message proxy.GetBackendResponse
 */
export interface GetBackendResponse {
    /**
     * @generated from protobuf field: repeated proxy.Backend Backend = 1 [json_name = "Backend"];
     */
    backend: Backend[];
}
/**
 * @generated from protobuf message proxy.GetServerResponse
 */
export interface GetServerResponse {
    /**
     * @generated from protobuf field: repeated proxy.Server Server = 1 [json_name = "Server"];
     */
    server: Server[];
}
/**
 * @generated from protobuf message proxy.RemoveRoutingRequest
 */
export interface RemoveRoutingRequest {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: bool Force = 2 [json_name = "Force"];
     */
    force: boolean;
    /**
     * @generated from protobuf field: string DevelopmentName = 3 [json_name = "DevelopmentName"];
     */
    developmentName: string;
    /**
     * @generated from protobuf field: bool RemoveByDevelopment = 4 [json_name = "RemoveByDevelopment"];
     */
    removeByDevelopment: boolean;
}
/**
 * @generated from protobuf message proxy.RemoveBackendRequest
 */
export interface RemoveBackendRequest {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: bool WaitToRequestFinish = 2 [json_name = "WaitToRequestFinish"];
     */
    waitToRequestFinish: boolean;
    /**
     * @generated from protobuf field: int32 WaitDurationToFinish = 3 [json_name = "WaitDurationToFinish"];
     */
    waitDurationToFinish: number;
    /**
     * @generated from protobuf field: string DevelopmentName = 4 [json_name = "DevelopmentName"];
     */
    developmentName: string;
    /**
     * @generated from protobuf field: bool RemoveByDevelopment = 5 [json_name = "RemoveByDevelopment"];
     */
    removeByDevelopment: boolean;
}
/**
 * @generated from protobuf message proxy.RemoveServerRequest
 */
export interface RemoveServerRequest {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: string BackendName = 2 [json_name = "BackendName"];
     */
    backendName: string;
    /**
     * @generated from protobuf field: bool WaitToRequestFinish = 3 [json_name = "WaitToRequestFinish"];
     */
    waitToRequestFinish: boolean;
    /**
     * @generated from protobuf field: int32 WaitDurationToFinish = 4 [json_name = "WaitDurationToFinish"];
     */
    waitDurationToFinish: number;
    /**
     * @generated from protobuf field: string DevelopmentName = 5 [json_name = "DevelopmentName"];
     */
    developmentName: string;
    /**
     * @generated from protobuf field: bool RemoveByDevelopment = 6 [json_name = "RemoveByDevelopment"];
     */
    removeByDevelopment: boolean;
    /**
     * @generated from protobuf field: string ContainerId = 7 [json_name = "ContainerId"];
     */
    containerId: string;
    /**
     * @generated from protobuf field: map<string, string> Labels = 8 [json_name = "Labels"];
     */
    labels: {
        [key: string]: string;
    };
}
/**
 * @generated from protobuf message proxy.SuspendServerRequest
 */
export interface SuspendServerRequest {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: string BackendName = 2 [json_name = "BackendName"];
     */
    backendName: string;
    /**
     * @generated from protobuf field: string ContainerId = 3 [json_name = "ContainerId"];
     */
    containerId: string;
}
/**
 * @generated from protobuf message proxy.Files
 */
export interface Files {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string; // @gotags: yaml:"name,omitempty" validate:"required"
    /**
     * @generated from protobuf field: bytes Value = 2 [json_name = "Value"];
     */
    value: Uint8Array; // @gotags: yaml:"value,omitempty" mapstructure:"value" validate:"required"
    /**
     * @generated from protobuf field: string DestinationDirectory = 3 [json_name = "DestinationDirectory"];
     */
    destinationDirectory: string; // @gotags: yaml:"destinationDirectory,omitempty" validate:"required"
}
/**
 * @generated from protobuf message proxy.SyncFilesRequest
 */
export interface SyncFilesRequest {
    /**
     * @generated from protobuf field: repeated proxy.Files Files = 1 [json_name = "Files"];
     */
    files: Files[];
}
/**
 * @generated from protobuf message proxy.ProxyInfoResponse
 */
export interface ProxyInfoResponse {
    /**
     * @generated from protobuf field: string StoragePath = 1 [json_name = "StoragePath"];
     */
    storagePath: string;
}
// @generated message type with reflection information, may provide speed optimized methods
class Configstore$Type extends MessageType<Configstore> {
    constructor() {
        super("proxy.Configstore", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Type", kind: "scalar", jsonName: "Type", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Data", kind: "scalar", jsonName: "Data", T: 12 /*ScalarType.BYTES*/ }
        ]);
    }
    create(value?: PartialMessage<Configstore>): Configstore {
        const message = { name: "", type: "", data: new Uint8Array(0) };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Configstore>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Configstore): Configstore {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string Type = 2 [json_name = "Type"];*/ 2:
                    message.type = reader.string();
                    break;
                case /* bytes Data = 3 [json_name = "Data"];*/ 3:
                    message.data = reader.bytes();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Configstore, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string Type = 2 [json_name = "Type"]; */
        if (message.type !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.type);
        /* bytes Data = 3 [json_name = "Data"]; */
        if (message.data.length)
            writer.tag(3, WireType.LengthDelimited).bytes(message.data);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.Configstore
 */
export const Configstore = new Configstore$Type();
// @generated message type with reflection information, may provide speed optimized methods
class GetListenerResponse$Type extends MessageType<GetListenerResponse> {
    constructor() {
        super("proxy.GetListenerResponse", [
            { no: 1, name: "Listener", kind: "message", jsonName: "Listener", repeat: 1 /*RepeatType.PACKED*/, T: () => Listener }
        ]);
    }
    create(value?: PartialMessage<GetListenerResponse>): GetListenerResponse {
        const message = { listener: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<GetListenerResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetListenerResponse): GetListenerResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated proxy.Listener Listener = 1 [json_name = "Listener"];*/ 1:
                    message.listener.push(Listener.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: GetListenerResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated proxy.Listener Listener = 1 [json_name = "Listener"]; */
        for (let i = 0; i < message.listener.length; i++)
            Listener.internalBinaryWrite(message.listener[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.GetListenerResponse
 */
export const GetListenerResponse = new GetListenerResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RemoveListenerRequest$Type extends MessageType<RemoveListenerRequest> {
    constructor() {
        super("proxy.RemoveListenerRequest", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "DevelopmentName", kind: "scalar", jsonName: "DevelopmentName", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "RemoveByDevelopment", kind: "scalar", jsonName: "RemoveByDevelopment", T: 8 /*ScalarType.BOOL*/ }
        ]);
    }
    create(value?: PartialMessage<RemoveListenerRequest>): RemoveListenerRequest {
        const message = { name: "", developmentName: "", removeByDevelopment: false };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RemoveListenerRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RemoveListenerRequest): RemoveListenerRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string DevelopmentName = 2 [json_name = "DevelopmentName"];*/ 2:
                    message.developmentName = reader.string();
                    break;
                case /* bool RemoveByDevelopment = 3 [json_name = "RemoveByDevelopment"];*/ 3:
                    message.removeByDevelopment = reader.bool();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: RemoveListenerRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string DevelopmentName = 2 [json_name = "DevelopmentName"]; */
        if (message.developmentName !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.developmentName);
        /* bool RemoveByDevelopment = 3 [json_name = "RemoveByDevelopment"]; */
        if (message.removeByDevelopment !== false)
            writer.tag(3, WireType.Varint).bool(message.removeByDevelopment);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.RemoveListenerRequest
 */
export const RemoveListenerRequest = new RemoveListenerRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class GetRoutingResponse$Type extends MessageType<GetRoutingResponse> {
    constructor() {
        super("proxy.GetRoutingResponse", [
            { no: 1, name: "Routing", kind: "message", jsonName: "Routing", repeat: 1 /*RepeatType.PACKED*/, T: () => Routing }
        ]);
    }
    create(value?: PartialMessage<GetRoutingResponse>): GetRoutingResponse {
        const message = { routing: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<GetRoutingResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetRoutingResponse): GetRoutingResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated proxy.Routing Routing = 1 [json_name = "Routing"];*/ 1:
                    message.routing.push(Routing.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: GetRoutingResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated proxy.Routing Routing = 1 [json_name = "Routing"]; */
        for (let i = 0; i < message.routing.length; i++)
            Routing.internalBinaryWrite(message.routing[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.GetRoutingResponse
 */
export const GetRoutingResponse = new GetRoutingResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class GetBackendResponse$Type extends MessageType<GetBackendResponse> {
    constructor() {
        super("proxy.GetBackendResponse", [
            { no: 1, name: "Backend", kind: "message", jsonName: "Backend", repeat: 1 /*RepeatType.PACKED*/, T: () => Backend }
        ]);
    }
    create(value?: PartialMessage<GetBackendResponse>): GetBackendResponse {
        const message = { backend: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<GetBackendResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetBackendResponse): GetBackendResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated proxy.Backend Backend = 1 [json_name = "Backend"];*/ 1:
                    message.backend.push(Backend.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: GetBackendResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated proxy.Backend Backend = 1 [json_name = "Backend"]; */
        for (let i = 0; i < message.backend.length; i++)
            Backend.internalBinaryWrite(message.backend[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.GetBackendResponse
 */
export const GetBackendResponse = new GetBackendResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class GetServerResponse$Type extends MessageType<GetServerResponse> {
    constructor() {
        super("proxy.GetServerResponse", [
            { no: 1, name: "Server", kind: "message", jsonName: "Server", repeat: 1 /*RepeatType.PACKED*/, T: () => Server }
        ]);
    }
    create(value?: PartialMessage<GetServerResponse>): GetServerResponse {
        const message = { server: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<GetServerResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetServerResponse): GetServerResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated proxy.Server Server = 1 [json_name = "Server"];*/ 1:
                    message.server.push(Server.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: GetServerResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated proxy.Server Server = 1 [json_name = "Server"]; */
        for (let i = 0; i < message.server.length; i++)
            Server.internalBinaryWrite(message.server[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.GetServerResponse
 */
export const GetServerResponse = new GetServerResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RemoveRoutingRequest$Type extends MessageType<RemoveRoutingRequest> {
    constructor() {
        super("proxy.RemoveRoutingRequest", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Force", kind: "scalar", jsonName: "Force", T: 8 /*ScalarType.BOOL*/ },
            { no: 3, name: "DevelopmentName", kind: "scalar", jsonName: "DevelopmentName", T: 9 /*ScalarType.STRING*/ },
            { no: 4, name: "RemoveByDevelopment", kind: "scalar", jsonName: "RemoveByDevelopment", T: 8 /*ScalarType.BOOL*/ }
        ]);
    }
    create(value?: PartialMessage<RemoveRoutingRequest>): RemoveRoutingRequest {
        const message = { name: "", force: false, developmentName: "", removeByDevelopment: false };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RemoveRoutingRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RemoveRoutingRequest): RemoveRoutingRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* bool Force = 2 [json_name = "Force"];*/ 2:
                    message.force = reader.bool();
                    break;
                case /* string DevelopmentName = 3 [json_name = "DevelopmentName"];*/ 3:
                    message.developmentName = reader.string();
                    break;
                case /* bool RemoveByDevelopment = 4 [json_name = "RemoveByDevelopment"];*/ 4:
                    message.removeByDevelopment = reader.bool();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: RemoveRoutingRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* bool Force = 2 [json_name = "Force"]; */
        if (message.force !== false)
            writer.tag(2, WireType.Varint).bool(message.force);
        /* string DevelopmentName = 3 [json_name = "DevelopmentName"]; */
        if (message.developmentName !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.developmentName);
        /* bool RemoveByDevelopment = 4 [json_name = "RemoveByDevelopment"]; */
        if (message.removeByDevelopment !== false)
            writer.tag(4, WireType.Varint).bool(message.removeByDevelopment);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.RemoveRoutingRequest
 */
export const RemoveRoutingRequest = new RemoveRoutingRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RemoveBackendRequest$Type extends MessageType<RemoveBackendRequest> {
    constructor() {
        super("proxy.RemoveBackendRequest", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "WaitToRequestFinish", kind: "scalar", jsonName: "WaitToRequestFinish", T: 8 /*ScalarType.BOOL*/ },
            { no: 3, name: "WaitDurationToFinish", kind: "scalar", jsonName: "WaitDurationToFinish", T: 5 /*ScalarType.INT32*/ },
            { no: 4, name: "DevelopmentName", kind: "scalar", jsonName: "DevelopmentName", T: 9 /*ScalarType.STRING*/ },
            { no: 5, name: "RemoveByDevelopment", kind: "scalar", jsonName: "RemoveByDevelopment", T: 8 /*ScalarType.BOOL*/ }
        ]);
    }
    create(value?: PartialMessage<RemoveBackendRequest>): RemoveBackendRequest {
        const message = { name: "", waitToRequestFinish: false, waitDurationToFinish: 0, developmentName: "", removeByDevelopment: false };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RemoveBackendRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RemoveBackendRequest): RemoveBackendRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* bool WaitToRequestFinish = 2 [json_name = "WaitToRequestFinish"];*/ 2:
                    message.waitToRequestFinish = reader.bool();
                    break;
                case /* int32 WaitDurationToFinish = 3 [json_name = "WaitDurationToFinish"];*/ 3:
                    message.waitDurationToFinish = reader.int32();
                    break;
                case /* string DevelopmentName = 4 [json_name = "DevelopmentName"];*/ 4:
                    message.developmentName = reader.string();
                    break;
                case /* bool RemoveByDevelopment = 5 [json_name = "RemoveByDevelopment"];*/ 5:
                    message.removeByDevelopment = reader.bool();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: RemoveBackendRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* bool WaitToRequestFinish = 2 [json_name = "WaitToRequestFinish"]; */
        if (message.waitToRequestFinish !== false)
            writer.tag(2, WireType.Varint).bool(message.waitToRequestFinish);
        /* int32 WaitDurationToFinish = 3 [json_name = "WaitDurationToFinish"]; */
        if (message.waitDurationToFinish !== 0)
            writer.tag(3, WireType.Varint).int32(message.waitDurationToFinish);
        /* string DevelopmentName = 4 [json_name = "DevelopmentName"]; */
        if (message.developmentName !== "")
            writer.tag(4, WireType.LengthDelimited).string(message.developmentName);
        /* bool RemoveByDevelopment = 5 [json_name = "RemoveByDevelopment"]; */
        if (message.removeByDevelopment !== false)
            writer.tag(5, WireType.Varint).bool(message.removeByDevelopment);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.RemoveBackendRequest
 */
export const RemoveBackendRequest = new RemoveBackendRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RemoveServerRequest$Type extends MessageType<RemoveServerRequest> {
    constructor() {
        super("proxy.RemoveServerRequest", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "BackendName", kind: "scalar", jsonName: "BackendName", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "WaitToRequestFinish", kind: "scalar", jsonName: "WaitToRequestFinish", T: 8 /*ScalarType.BOOL*/ },
            { no: 4, name: "WaitDurationToFinish", kind: "scalar", jsonName: "WaitDurationToFinish", T: 5 /*ScalarType.INT32*/ },
            { no: 5, name: "DevelopmentName", kind: "scalar", jsonName: "DevelopmentName", T: 9 /*ScalarType.STRING*/ },
            { no: 6, name: "RemoveByDevelopment", kind: "scalar", jsonName: "RemoveByDevelopment", T: 8 /*ScalarType.BOOL*/ },
            { no: 7, name: "ContainerId", kind: "scalar", jsonName: "ContainerId", T: 9 /*ScalarType.STRING*/ },
            { no: 8, name: "Labels", kind: "map", jsonName: "Labels", K: 9 /*ScalarType.STRING*/, V: { kind: "scalar", T: 9 /*ScalarType.STRING*/ } }
        ]);
    }
    create(value?: PartialMessage<RemoveServerRequest>): RemoveServerRequest {
        const message = { name: "", backendName: "", waitToRequestFinish: false, waitDurationToFinish: 0, developmentName: "", removeByDevelopment: false, containerId: "", labels: {} };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RemoveServerRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RemoveServerRequest): RemoveServerRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string BackendName = 2 [json_name = "BackendName"];*/ 2:
                    message.backendName = reader.string();
                    break;
                case /* bool WaitToRequestFinish = 3 [json_name = "WaitToRequestFinish"];*/ 3:
                    message.waitToRequestFinish = reader.bool();
                    break;
                case /* int32 WaitDurationToFinish = 4 [json_name = "WaitDurationToFinish"];*/ 4:
                    message.waitDurationToFinish = reader.int32();
                    break;
                case /* string DevelopmentName = 5 [json_name = "DevelopmentName"];*/ 5:
                    message.developmentName = reader.string();
                    break;
                case /* bool RemoveByDevelopment = 6 [json_name = "RemoveByDevelopment"];*/ 6:
                    message.removeByDevelopment = reader.bool();
                    break;
                case /* string ContainerId = 7 [json_name = "ContainerId"];*/ 7:
                    message.containerId = reader.string();
                    break;
                case /* map<string, string> Labels = 8 [json_name = "Labels"];*/ 8:
                    this.binaryReadMap8(message.labels, reader, options);
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    private binaryReadMap8(map: RemoveServerRequest["labels"], reader: IBinaryReader, options: BinaryReadOptions): void {
        let len = reader.uint32(), end = reader.pos + len, key: keyof RemoveServerRequest["labels"] | undefined, val: RemoveServerRequest["labels"][any] | undefined;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case 1:
                    key = reader.string();
                    break;
                case 2:
                    val = reader.string();
                    break;
                default: throw new globalThis.Error("unknown map entry field for field proxy.RemoveServerRequest.Labels");
            }
        }
        map[key ?? ""] = val ?? "";
    }
    internalBinaryWrite(message: RemoveServerRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string BackendName = 2 [json_name = "BackendName"]; */
        if (message.backendName !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.backendName);
        /* bool WaitToRequestFinish = 3 [json_name = "WaitToRequestFinish"]; */
        if (message.waitToRequestFinish !== false)
            writer.tag(3, WireType.Varint).bool(message.waitToRequestFinish);
        /* int32 WaitDurationToFinish = 4 [json_name = "WaitDurationToFinish"]; */
        if (message.waitDurationToFinish !== 0)
            writer.tag(4, WireType.Varint).int32(message.waitDurationToFinish);
        /* string DevelopmentName = 5 [json_name = "DevelopmentName"]; */
        if (message.developmentName !== "")
            writer.tag(5, WireType.LengthDelimited).string(message.developmentName);
        /* bool RemoveByDevelopment = 6 [json_name = "RemoveByDevelopment"]; */
        if (message.removeByDevelopment !== false)
            writer.tag(6, WireType.Varint).bool(message.removeByDevelopment);
        /* string ContainerId = 7 [json_name = "ContainerId"]; */
        if (message.containerId !== "")
            writer.tag(7, WireType.LengthDelimited).string(message.containerId);
        /* map<string, string> Labels = 8 [json_name = "Labels"]; */
        for (let k of Object.keys(message.labels))
            writer.tag(8, WireType.LengthDelimited).fork().tag(1, WireType.LengthDelimited).string(k).tag(2, WireType.LengthDelimited).string(message.labels[k]).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.RemoveServerRequest
 */
export const RemoveServerRequest = new RemoveServerRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class SuspendServerRequest$Type extends MessageType<SuspendServerRequest> {
    constructor() {
        super("proxy.SuspendServerRequest", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "BackendName", kind: "scalar", jsonName: "BackendName", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "ContainerId", kind: "scalar", jsonName: "ContainerId", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<SuspendServerRequest>): SuspendServerRequest {
        const message = { name: "", backendName: "", containerId: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<SuspendServerRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: SuspendServerRequest): SuspendServerRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string BackendName = 2 [json_name = "BackendName"];*/ 2:
                    message.backendName = reader.string();
                    break;
                case /* string ContainerId = 3 [json_name = "ContainerId"];*/ 3:
                    message.containerId = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: SuspendServerRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string BackendName = 2 [json_name = "BackendName"]; */
        if (message.backendName !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.backendName);
        /* string ContainerId = 3 [json_name = "ContainerId"]; */
        if (message.containerId !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.containerId);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.SuspendServerRequest
 */
export const SuspendServerRequest = new SuspendServerRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Files$Type extends MessageType<Files> {
    constructor() {
        super("proxy.Files", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Value", kind: "scalar", jsonName: "Value", T: 12 /*ScalarType.BYTES*/ },
            { no: 3, name: "DestinationDirectory", kind: "scalar", jsonName: "DestinationDirectory", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<Files>): Files {
        const message = { name: "", value: new Uint8Array(0), destinationDirectory: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Files>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Files): Files {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* bytes Value = 2 [json_name = "Value"];*/ 2:
                    message.value = reader.bytes();
                    break;
                case /* string DestinationDirectory = 3 [json_name = "DestinationDirectory"];*/ 3:
                    message.destinationDirectory = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Files, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* bytes Value = 2 [json_name = "Value"]; */
        if (message.value.length)
            writer.tag(2, WireType.LengthDelimited).bytes(message.value);
        /* string DestinationDirectory = 3 [json_name = "DestinationDirectory"]; */
        if (message.destinationDirectory !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.destinationDirectory);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.Files
 */
export const Files = new Files$Type();
// @generated message type with reflection information, may provide speed optimized methods
class SyncFilesRequest$Type extends MessageType<SyncFilesRequest> {
    constructor() {
        super("proxy.SyncFilesRequest", [
            { no: 1, name: "Files", kind: "message", jsonName: "Files", repeat: 1 /*RepeatType.PACKED*/, T: () => Files }
        ]);
    }
    create(value?: PartialMessage<SyncFilesRequest>): SyncFilesRequest {
        const message = { files: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<SyncFilesRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: SyncFilesRequest): SyncFilesRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated proxy.Files Files = 1 [json_name = "Files"];*/ 1:
                    message.files.push(Files.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: SyncFilesRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated proxy.Files Files = 1 [json_name = "Files"]; */
        for (let i = 0; i < message.files.length; i++)
            Files.internalBinaryWrite(message.files[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.SyncFilesRequest
 */
export const SyncFilesRequest = new SyncFilesRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ProxyInfoResponse$Type extends MessageType<ProxyInfoResponse> {
    constructor() {
        super("proxy.ProxyInfoResponse", [
            { no: 1, name: "StoragePath", kind: "scalar", jsonName: "StoragePath", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<ProxyInfoResponse>): ProxyInfoResponse {
        const message = { storagePath: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ProxyInfoResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProxyInfoResponse): ProxyInfoResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string StoragePath = 1 [json_name = "StoragePath"];*/ 1:
                    message.storagePath = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ProxyInfoResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string StoragePath = 1 [json_name = "StoragePath"]; */
        if (message.storagePath !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.storagePath);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message proxy.ProxyInfoResponse
 */
export const ProxyInfoResponse = new ProxyInfoResponse$Type();
